require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SOCKET_H)) {
    die("Never include <bits/socket-constants.h> directly; use <sys/socket.h> instead.");
}
eval 'sub SOL_SOCKET () {65535;}' unless defined(&SOL_SOCKET);
eval 'sub SO_ACCEPTCONN () {32768;}' unless defined(&SO_ACCEPTCONN);
eval 'sub SO_BROADCAST () {32;}' unless defined(&SO_BROADCAST);
eval 'sub SO_DONTROUTE () {16;}' unless defined(&SO_DONTROUTE);
eval 'sub SO_ERROR () {4103;}' unless defined(&SO_ERROR);
eval 'sub SO_KEEPALIVE () {8;}' unless defined(&SO_KEEPALIVE);
eval 'sub SO_LINGER () {128;}' unless defined(&SO_LINGER);
eval 'sub SO_OOBINLINE () {256;}' unless defined(&SO_OOBINLINE);
eval 'sub SO_RCVBUF () {4098;}' unless defined(&SO_RCVBUF);
eval 'sub SO_RCVLOWAT () {2048;}' unless defined(&SO_RCVLOWAT);
eval 'sub SO_REUSEADDR () {4;}' unless defined(&SO_REUSEADDR);
eval 'sub SO_SNDBUF () {4097;}' unless defined(&SO_SNDBUF);
eval 'sub SO_SNDLOWAT () {4096;}' unless defined(&SO_SNDLOWAT);
eval 'sub SO_TYPE () {4104;}' unless defined(&SO_TYPE);
if((defined(&__TIMESIZE) ? &__TIMESIZE : undef) == 64) {
    eval 'sub SO_RCVTIMEO () {8192;}' unless defined(&SO_RCVTIMEO);
    eval 'sub SO_SNDTIMEO () {16384;}' unless defined(&SO_SNDTIMEO);
    eval 'sub SO_TIMESTAMP () {29;}' unless defined(&SO_TIMESTAMP);
    eval 'sub SO_TIMESTAMPNS () {33;}' unless defined(&SO_TIMESTAMPNS);
    eval 'sub SO_TIMESTAMPING () {35;}' unless defined(&SO_TIMESTAMPING);
} else {
    eval 'sub SO_RCVTIMEO_OLD () {8192;}' unless defined(&SO_RCVTIMEO_OLD);
    eval 'sub SO_SNDTIMEO_OLD () {16384;}' unless defined(&SO_SNDTIMEO_OLD);
    eval 'sub SO_RCVTIMEO_NEW () {68;}' unless defined(&SO_RCVTIMEO_NEW);
    eval 'sub SO_SNDTIMEO_NEW () {69;}' unless defined(&SO_SNDTIMEO_NEW);
    eval 'sub SO_TIMESTAMP_OLD () {0x1d;}' unless defined(&SO_TIMESTAMP_OLD);
    eval 'sub SO_TIMESTAMPNS_OLD () {0x21;}' unless defined(&SO_TIMESTAMPNS_OLD);
    eval 'sub SO_TIMESTAMPING_OLD () {0x23;}' unless defined(&SO_TIMESTAMPING_OLD);
    eval 'sub SO_TIMESTAMP_NEW () {0x46;}' unless defined(&SO_TIMESTAMP_NEW);
    eval 'sub SO_TIMESTAMPNS_NEW () {0x42;}' unless defined(&SO_TIMESTAMPNS_NEW);
    eval 'sub SO_TIMESTAMPING_NEW () {0x43;}' unless defined(&SO_TIMESTAMPING_NEW);
    if(defined(&__USE_TIME64_REDIRECTS)) {
	eval 'sub SO_RCVTIMEO () { &SO_RCVTIMEO_NEW;}' unless defined(&SO_RCVTIMEO);
	eval 'sub SO_SNDTIMEO () { &SO_SNDTIMEO_NEW;}' unless defined(&SO_SNDTIMEO);
	eval 'sub SO_TIMESTAMP () { &SO_TIMESTAMP_NEW;}' unless defined(&SO_TIMESTAMP);
	eval 'sub SO_TIMESTAMPNS () { &SO_TIMESTAMPNS_NEW;}' unless defined(&SO_TIMESTAMPNS);
	eval 'sub SO_TIMESTAMPING () { &SO_TIMESTAMPING_NEW;}' unless defined(&SO_TIMESTAMPING);
    } else {
	eval 'sub SO_RCVTIMEO () { &SO_RCVTIMEO_OLD;}' unless defined(&SO_RCVTIMEO);
	eval 'sub SO_SNDTIMEO () { &SO_SNDTIMEO_OLD;}' unless defined(&SO_SNDTIMEO);
	eval 'sub SO_TIMESTAMP () { &SO_TIMESTAMP_OLD;}' unless defined(&SO_TIMESTAMP);
	eval 'sub SO_TIMESTAMPNS () { &SO_TIMESTAMPNS_OLD;}' unless defined(&SO_TIMESTAMPNS);
	eval 'sub SO_TIMESTAMPING () { &SO_TIMESTAMPING_OLD;}' unless defined(&SO_TIMESTAMPING);
    }
}
1;
